<?php

namespace Drupal\gitlab_api\Plugin\WebformHandler;

use Drupal\webform\Plugin\WebformHandlerBase;
use Drupal\webform\WebformSubmissionInterface;

/**
 * Webform submission handler to create a new GitLab project.
 *
 * @WebformHandler(
 *   id = "gitlab_api_create_project",
 *   label = @Translation("Create Project"),
 *   category = @Translation("GitLab"),
 *   description = @Translation("Create a new GitLab project."),
 *   cardinality = \Drupal\webform\Plugin\WebformHandlerInterface::CARDINALITY_UNLIMITED,
 *   results = \Drupal\webform\Plugin\WebformHandlerInterface::RESULTS_PROCESSED,
 *   submission = \Drupal\webform\Plugin\WebformHandlerInterface::SUBMISSION_REQUIRED,
 *   tokens = TRUE,
 * )
 */
class CreateProject extends WebformHandlerBase {

  public function postSave(WebformSubmissionInterface $webform_submission, $update = TRUE) {
    $state = $webform_submission->getWebform()->getSetting('results_disabled') ?
      WebformSubmissionInterface::STATE_COMPLETED :
      $webform_submission->getState();
    if ($this->configuration['states'] && in_array($state, $this->configuration['states'], TRUE)) {
      $data = $webform_submission->getData();

      $data['gitlab_project'] = '';
      $webform_submission->setData($data);
      $webform_submission->save();
    }
  }

}
